﻿using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;

namespace GameServer
{
    class Program
    {
        static void Main(string[] args)
        {
            LobbySkeleton lobbySkeleton = new LobbySkeleton(new Lobby());
            lobbySkeleton.Listen();

            TcpChannel channel = new TcpChannel(8080);
            ChannelServices.RegisterChannel(channel, false);

            RemotingConfiguration.RegisterWellKnownServiceType(typeof(Lobby), "Lobby", WellKnownObjectMode.Singleton);

            Console.WriteLine("Press the enter key to exit...");
            Console.ReadLine();

            ChannelServices.UnregisterChannel(channel);
            lobbySkeleton.Stop();
        }
    }
}
