﻿using System;
using System.Threading;
using System.Text;
using System.Collections.Generic;
using System.Net;
using System.Net.Sockets;

using RemotingInterfaces;

namespace Proxy.Lobby
{
    public class LobbyProxy: ILobby
    {
        private Socket ClientSocket { get; set; }

        public LobbyProxy()
        {
            ClientSocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            IPAddress remoteIP = IPAddress.Parse("127.0.0.1");
            IPEndPoint remoteServer = new IPEndPoint(remoteIP, 8081);
            ClientSocket.Connect(remoteServer);
        }

        public int TotalUsers
        {
            get
            {
                Send("TotalUsers$");
                Thread.Sleep(500);
                string data = Receive();
                return Convert.ToInt32(data);
            }
        }

        public List<string> Users
        {
            get
            {
                Send("Users$");
                Thread.Sleep(500);
                string data = Receive();
                return new List<string>(data.Split('|'));
            }
        }

        public void RegisterUser(string userName)
        {
            Send(string.Format("RegisterUser${0}", userName));
            Thread.Sleep(500);
            string data = Receive();
            if (data != "OK") { throw new Exception("Something blew up"); }
        }

        // This is the code that sends calls over the wire to the real object
        private void Send(string command)
        {
            byte[] commandData = Encoding.ASCII.GetBytes(command);
            ClientSocket.Send(commandData);
        }

        private string Receive()
        {
            byte[] buffer = new byte[1024];
            int iRx = ClientSocket.Receive(buffer);
            char[] chars = new char[iRx];

            Decoder d = Encoding.UTF8.GetDecoder();
            int charLen = d.GetChars(buffer, 0, iRx, chars, 0);

            String socketData = new String(chars);
            return socketData;
        }
    }
}
